#!/usr/bin/env bash
source /etc/os-release

set -euo pipefail

# Download latest release
if [[ ! -d "sftpgo-src" ]]; then
	git clone https://github.com/drakkan/sftpgo sftpgo-src
fi
cd sftpgo-src
git checkout main
git pull origin HEAD
git checkout $(git tag | tail -n 1)

# Prepare
cp -r openapi ./internal/bundle/openapi
cp -r templates ./internal/bundle/templates
cp -r static ./internal/bundle/static

# Build
go build -tags nogcs,nos3,noazblob,nobolt,nomysql,nopgsql,nosqlite,noportable,nometrics,bundle -o sftpgo
strip /usr/local/bin/sftpgo

# Install
mv sftpgo /usr/local/bin/
